"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Mustache = require("mustache");
var fs_1 = require("./fs");
var json_schema_util_1 = require("./json-schema-util");
var mustache_data_view_util_1 = require("./mustache-data-view-util");
function generate(schemaPath, outputPath) {
    function render(view) {
        return fs_1.readFile("./etc/template.mustache").then(function (template) {
            return fs_1.writeFile(outputPath, Mustache.render(template, view));
        });
    }
    return fs_1.readFile(schemaPath).then(json_schema_util_1.parse).then(mustache_data_view_util_1.convert).then(render);
}
exports.generate = generate;
