"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parsePerson(json) {
    var obj = JSON.parse(json);
    return unmarshalPerson(obj);
}
exports.parsePerson = parsePerson;
function unmarshalPerson(obj) {
    if (obj === undefined || obj === null || typeof obj !== "object") {
        throw new Error("Expected object but actually found " + obj);
    }
    else {
        return {
            age: opt(function () { return unmarshalNumber(obj.age); }),
            firstName: unmarshalString(obj.firstName),
            lastName: unmarshalString(obj.lastName),
        };
    }
}
exports.unmarshalPerson = unmarshalPerson;
function unmarshalArray(as, unmarshalT) {
    if (as === undefined || as === null || !Array.isArray(as)) {
        throw new Error("Expected array but actually found " + as);
    }
    else {
        return as.map(function (a) { return unmarshalT(a); });
    }
}
function unmarshalString(a) {
    if (a === undefined || a === null || typeof a !== "string") {
        throw new Error("Expected string but actually found " + a);
    }
    else {
        return a;
    }
}
function unmarshalNumber(a) {
    if (a === undefined || a === null || typeof a !== "number") {
        throw new Error("Expected number but actually found " + a);
    }
    else {
        return a;
    }
}
function unmarshalBoolean(a) {
    if (a === undefined || a === null || typeof a !== "boolean") {
        throw new Error("Expected boolean but actually found " + a);
    }
    else {
        return a;
    }
}
function opt(f) {
    try {
        return f();
    }
    catch (e) {
        return undefined;
    }
}
